<?php

namespace SM\Controller;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use SM\Service\AgendamentoRecursosService;
use SM\Traits\TResponse;

class AgendamentoRecursosController
{
    use TResponse;
    
    protected $agendamentoRecursosService;
    
    public function __construct(AgendamentoRecursosService $agendamentoRecursosService)
    {
        $this->agendamentoRecursosService = $agendamentoRecursosService;
    }
    
    public function getAgendamentoRecursoCont()
    {
        try {
            $data = $this->agendamentoRecursosService->getAgendamentoRecursoCont();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function saveAgendRecursos(Request $request)
    {
        try {
            $data = $this->agendamentoRecursosService->saveAgendRecursos($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    } 

    public function deleteAgendRecursos(Request $request)
    {
        try {
            $data = $this->agendamentoRecursosService->deleteAgendRecursos($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getRelacEstruturaCont(Request $request)
    {
        try {
            $data = $this->agendamentoRecursosService->getRelacEstruturaCont($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    } 

    public function getContratosAgendRecurso()
    {
        try {
            $data = $this->agendamentoRecursosService->getContratosAgendRecurso();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getRecursosAgendCont(Request $request)
    {
        try {
            $data = $this->agendamentoRecursosService->getRecursosAgendCont($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
    
    public function getItemContAgendRecurso(Request $request)
    {
        try {
            $data = $this->agendamentoRecursosService->getItemContAgendRecurso($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getRecursoAgendCont(Request $request)
    {
        try {
            $data = $this->agendamentoRecursosService->getRecursoAgendCont($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}