<?php

namespace SM\Controller;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use SM\Service\EquipeTrabalhoService;
use SM\Traits\TResponse;

class EquipeTrabalhoController
{
    use TResponse;
    
    protected $equipeTrabalhoService;
    
    public function __construct(EquipeTrabalhoService $equipeTrabalhoService)
    {
        $this->equipeTrabalhoService = $equipeTrabalhoService;
    }

    public function getFctViewRecursos(Request $request) {
        try {
            $data = $this->equipeTrabalhoService->getFctViewRecursos($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        } 
    }

    public function updateRecursoEquipeTrabalho(Request $request) {
        try {
            $data = $this->equipeTrabalhoService->updateRecursoEquipeTrabalho($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        } 
    }

    public function insertRecursoEquipeTrabalho(Request $request) {
        try {
            $data = $this->equipeTrabalhoService->insertRecursoEquipeTrabalho($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        } 
    } 

    public function deleteRecursos(Request $request)
    {
        try {
            $data = $this->equipeTrabalhoService->deleteRecursos($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}