<?php

namespace SM\Factory;

use Doctrine\ORM\EntityManager;
use Teknisa\Model\Traits\TQuery;

class EquipeTrabalhoFactory
{
    use TQuery;

    protected $connection;

    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function getFctViewRecursos($parametros)
    {
        $sql = "SELECT
                    NMRECURSO,
                    CODRECURSO,
                    CHAVE,
                    CDEMPRESA,
                    CDTIPO,
                    NMTIPO,
                    NRORG
                FROM
                    FCT_VIEW_RECURSOS VIEWREC
                WHERE
                    VIEWREC.CHAVE NOT IN (
                        SELECT
                            NVL(TO_CHAR(EQUIPE.NRPARCNEPESSOA),
                                NVL(EQUIPE.CDBEMATIVO, EQUIPE.CDPRODUTO))
                        FROM
                            FCT_RECURSOSAGENDCONT EQUIPE
                        WHERE
                                EQUIPE.IDSITUARECGEND = 1
                            AND ( ( TO_DATE(:DTINIAGENDRECURSO, 'DD/MM/YY') BETWEEN TO_DATE(TO_CHAR(EQUIPE.DTINIAGENDRECURSO, 'DD/MM/YY'),
                        'DD/MM/YY') AND TO_DATE(TO_CHAR(EQUIPE.DTFIMAGENDRECURSO, 'DD/MM/YY'),
                        'DD/MM/YY')
                                    OR TO_DATE(:DTFIMAGENDRECURSO, 'DD/MM/YY') BETWEEN TO_DATE(TO_CHAR(EQUIPE.DTINIAGENDRECURSO, 'DD/MM/YY'),
                        'DD/MM/YY') AND TO_DATE(TO_CHAR(EQUIPE.DTFIMAGENDRECURSO, 'DD/MM/YY'),
                        'DD/MM/YY') )
                                OR TO_CHAR(DTINIAGENDRECURSO, 'DD/MM/YY') BETWEEN TO_DATE(:DTINIAGENDRECURSO, 'DD/MM/YY') AND TO_DATE(:DTFIMAGENDRECURSO
                                , 'DD/MM/YY')
                                OR TO_CHAR(DTFIMAGENDRECURSO, 'DD/MM/YY') BETWEEN TO_DATE(:DTINIAGENDRECURSO, 'DD/MM/YY') AND TO_DATE(:DTFIMAGENDRECURSO
                                , 'DD/MM/YY') )
                            AND ( ( ( :IDREPETDOMINGO = 'S'
                                    AND EQUIPE.IDREPETDOMINGO = 'S' )
                                    OR ( :IDREPETSEGUNDA = 'S'
                                        AND EQUIPE.IDREPETSEGUNDA = 'S' )
                                    OR ( :IDREPETTERCA = 'S'
                                        AND EQUIPE.IDREPETTERCA = 'S' )
                                    OR ( :IDREPETQUARTA = 'S'
                                        AND EQUIPE.IDREPETQUARTA = 'S' )
                                    OR ( :IDREPETQUINTA = 'S'
                                        AND EQUIPE.IDREPETQUINTA = 'S' )
                                    OR ( :IDREPETSEXTA = 'S'
                                        AND EQUIPE.IDREPETSEXTA = 'S' )
                                    OR ( :IDREPETSABADO = 'S'
                                        AND EQUIPE.IDREPETSABADO = 'S' ) ) )
                    )";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $parametros);
    }

    public function updateRecursoEquipeTrabalho($parametros) {

        $sql = "UPDATE FCT_RECURSOSAGENDCONT
                SET HRPRIMEIRAENTRADA       = :HRPRIMEIRAENTRADA,
                    HRPRIMEIRASAIDA         = :HRPRIMEIRASAIDA,
                    HRSEGUNDAENTRADA        = :HRSEGUNDAENTRADA,
                    HRSEGUNDASAIDA          = :HRSEGUNDASAIDA,
                    NRTEMPOTOLERANCIA       = :NRTEMPOTOLERANCIA,
                    IDHORAEXTRA             = :IDHORAEXTRA,
                    IDDESCANSOREMU          = :IDDESCANSOREMU,
                    IDESCALATRAB            = :IDESCALATRAB,
                    HRJORNADADIARIA         = :HRJORNADADIARIA,
                    HRINTERVALO             = :HRINTERVALO,
                    HRDESCANSO              = :HRDESCANSO,
                    DTULTATU                = SYSDATE,
                    NRORG                   = :NRORG,
                    IDATIVO                 = :IDATIVO,
                    NRORGULTATU             = :NRORGULTATU,
                    CDOPERULTATU            = :CDOPERULTATU
                WHERE NRRECURSOSAGENDCONT = :NRRECURSOSAGENDCONT
                AND NRORG = :NRORG";
        
        $this->connection->executeStatement($sql, $parametros);
    }

    public function insertRecursoEquipeTrabalho($parametros) {
        $sql = "INSERT INTO FCT_RECURSOSAGENDCONT ( NRRECURSOSAGENDCONT, NRAGENDRECURSOCONT, NRITEMOCONTRATO, DTINIAGENDRECURSO, DTFIMAGENDRECURSO, IDREPETDOMINGO, IDREPETSEGUNDA, IDREPETTERCA, IDREPETQUARTA, IDREPETQUINTA, IDREPETSEXTA, IDREPETSABADO, NRPARCNEPESSOA, IDTPRECURSO, IDMOTIVOAGENDAMENTO, IDSITUARECGEND, HRPRIMEIRAENTRADA, HRPRIMEIRASAIDA, HRSEGUNDAENTRADA, HRSEGUNDASAIDA, NRTEMPOTOLERANCIA, IDHORAEXTRA, IDDESCANSOREMU, IDESCALATRAB, HRJORNADADIARIA, HRINTERVALO, HRDESCANSO, NRORG, DTINCLUSAO, IDATIVO, NRORGINCLUSAO, CDOPERINCLUSAO)
                    VALUES ( :NRRECURSOSAGENDCONT, :NRAGENDRECURSOCONT, :NRITEMOCONTRATO, :DTINIAGENDRECURSO, :DTFIMAGENDRECURSO, :IDREPETDOMINGO, :IDREPETSEGUNDA, :IDREPETTERCA, :IDREPETQUARTA, :IDREPETQUINTA, :IDREPETSEXTA, :IDREPETSABADO, :NRPARCNEPESSOA, :IDTPRECURSO, :IDMOTIVOAGENDAMENTO, :IDSITUARECGEND, :HRPRIMEIRAENTRADA, :HRPRIMEIRASAIDA, :HRSEGUNDAENTRADA, :HRSEGUNDASAIDA, :NRTEMPOTOLERANCIA, :IDHORAEXTRA, :IDDESCANSOREMU, :IDESCALATRAB, :HRJORNADADIARIA, :HRINTERVALO, :HRDESCANSO, :NRORG, SYSDATE, :IDATIVO, :NRORGINCLUSAO, :CDOPERINCLUSAO)";
        $this->connection->executeStatement($sql, $parametros);
    }

    public function validarPeriodosAlocacao(array $params) {
        $sql = "SELECT COUNT(*) QTALOCADO,
                    QTITEMCONTRATO,
                    IDREPETDOMINGO,
                    IDREPETSEGUNDA,
                    IDREPETTERCA,
                    IDREPETQUARTA,
                    IDREPETQUINTA,
                    IDREPETSEXTA,
                    IDREPETSABADO
                FROM (SELECT DECODE(EQUIPE.IDDESCANSOREMU, 'S', 'S', EQUIPE.IDREPETDOMINGO) AS IDREPETDOMINGO,
                        DECODE(EQUIPE.IDDESCANSOREMU, 'S', 'S', EQUIPE.IDREPETSEGUNDA) AS IDREPETSEGUNDA,
                        DECODE(EQUIPE.IDDESCANSOREMU, 'S', 'S', EQUIPE.IDREPETTERCA) AS IDREPETTERCA,
                        DECODE(EQUIPE.IDDESCANSOREMU, 'S', 'S', EQUIPE.IDREPETQUARTA) AS IDREPETQUARTA,
                        DECODE(EQUIPE.IDDESCANSOREMU, 'S', 'S', EQUIPE.IDREPETQUINTA) AS IDREPETQUINTA,
                        DECODE(EQUIPE.IDDESCANSOREMU, 'S', 'S', EQUIPE.IDREPETSEXTA) AS IDREPETSEXTA,
                        DECODE(EQUIPE.IDDESCANSOREMU, 'S', 'S', EQUIPE.IDREPETSABADO) AS IDREPETSABADO,
                        ITEMCONT.QTITEMCONTRATO
                      FROM FCT_RECURSOSAGENDCONT EQUIPE
                      JOIN FCT_ITEMCONTRATO ITEMCONT
                        ON EQUIPE.NRITEMOCONTRATO = ITEMCONT.NRITEMOCONTRATO
                        AND EQUIPE.NRORG          = ITEMCONT.NRORG
                      WHERE EQUIPE.NRITEMOCONTRATO    = :NRITEMOCONTRATO
                        AND EQUIPE.NRORG              = :NRORG
                        AND EQUIPE.IDSITUARECGEND     = '1'
                        AND EQUIPE.NRAGENDRECURSOCONT = :NRAGENDRECURSOCONT
                        AND (:DTINIAGENDRECURSO BETWEEN DTINIAGENDRECURSO AND DTFIMAGENDRECURSO
                             OR :DTFIMAGENDRECURSO BETWEEN DTINIAGENDRECURSO AND DTFIMAGENDRECURSO
                             OR DTINIAGENDRECURSO BETWEEN :DTINIAGENDRECURSO AND :DTFIMAGENDRECURSO
                             OR DTFIMAGENDRECURSO BETWEEN :DTINIAGENDRECURSO AND :DTFIMAGENDRECURSO))
                GROUP BY  QTITEMCONTRATO,
                    IDREPETDOMINGO,
                    IDREPETSEGUNDA,
                    IDREPETTERCA,
                    IDREPETQUARTA,
                    IDREPETQUINTA,
                    IDREPETSEXTA,
                    IDREPETSABADO";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }

    public function deleteRecursos($parametros)
    {
        $sql = "DELETE FROM FCT_RECURSOSAGENDCONT WHERE NRRECURSOSAGENDCONT IN ($parametros)";

        $this->connection->executeStatement($sql);
    }
}