<?php

namespace SM\Factory;

use Doctrine\ORM\EntityManager;
use \Teknisa\Model\Traits\TQuery;

class Sm00005000TabParametrizacoesServicesFactory
{
    use TQuery;

    protected $connection;

    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function getParametrosGeral()
    {
        $sql = "SELECT
        (SELECT Listagg(NRPERFILACESSO, ',') WITHIN GROUP(
                                                          ORDER BY NRPERFILACESSO)
         FROM FCT_ALTPROPCONCPERF) AS FCT_ALTPROPCONCPERF,
      
        (SELECT Listagg(NRPERFILACESSO, ',') WITHIN GROUP(
                                                          ORDER BY NRPERFILACESSO)
         FROM FCT_ALTCONTRAPROVPERF) AS FCT_ALTCONTRAPROVPERF,
        PARAM.NRPARAMETROGERAL,
        PARAM.CDGRUPPRODORCA,
        PARAM.NRORG,
        PARAM.IDATIVO,
        PARAM.DTINCLUSAO,
        PARAM.DTULTATU,
        PARAM.NRORGINCLUSAO,
        PARAM.CDOPERINCLUSAO,
        PARAM.NRORGULTATU,
        PARAM.CDOPERULTATU,
        PARAM.IDGERARECURSO,
        PARAM.IDINICFATURA,
        PARAM.QTDIASDESALOCREC,
        PARAM.DSEMAILSDESALCREC,
        PARAM.IDALTERAMODCON,
        PARAM.IDALTERATABPREC,
        PARAM.CDMOTIVOACEITE,
        PARAM.CDMOTIVOENVIO,
        PARAM.CDINDFINCONT,
        PARAM.CDTPINDFINCON,
        PARAM.IDPERVALFINCON,
        PARAM.NRSEQMODCONTRATO,
        PARAM.CDMODCONTRATO,
        PARAM.IDOBRIGMODORC,
        PARAM.NRINISEQCODORCA,
        PARAM.NRINISEQCODCONT,
        PARAM.QTDIASALERTACONTRATO,
        PARAM.IDUTILIZAHIEROPER,
        PARAM.IDINTEGRACAOOM,
        PARAM.URLINTEGRACAOOM,
        PARAM.IDCONVERSAOPROSPECT,
        PARAM.IDCONVCLIENTE,
        PARAM.IDINTEGRACAOCRM,
        PARAM.URLINTEGRACAOCRM,
        PARAM.IDALTERAPROPCONC,
        PARAM.IDALTERACONTAPROV,
        PARAM.NRORCAMODELOCUST,
        MODPRO.NMORCAMENTOMODELO AS NMORCAMODELOCUST,
        PARAM.CDPRECBASESERVCUST,
        PRECO.DSPRECBASESERV AS DSPRECBASESERVCUST,
        PARAM.DSHOSTEMAIL,
        PARAM.DSPORTAEMAIL,
        PARAM.DSUSUARIOEMAIL,
        PARAM.DSSENHAEMAIL,
        PARAM.IDBLOQREAJSEMALIQ,
        PARAM.IDBLOQAPURFATSEMREAJ,
        PARAM.DSEMAILALERTRENOVCONT,
        PARAM.IDPERIODALERTRENOVCONT,
        PARAM.DSTOKENCERTSIGN,
        PARAM.NMSENDERCERTSIGN,
        PARAM.DSEMAILSENDERCERTSIGN,
        PARAM.NRCPFSENDERCERTSIGN,
        PARAM.IDSMTPSECURE,
        PARAM.IDBUSCADTVENCNF,
        PARAM.NRTIPODOCCERTSIGN,
        TIPODOC.NMTIPODOCCERTSIGN,
        PARAM.IDPADRAOASSINACERTSIGN,
        PARAM.IDBLOQCARENCMAXI,
        PARAM.IDVALIDACPFRF,
        PARAM.URLINTEGRACAOERPFILIAL,
        PARAM.DSURLINTEGRACAOFM,
        PARAM.NRTIPOLOCALCLIFM,
        PARAM.URLINTEGRACAOTECFOOD,
        FCM_TIPOLOCALCLI.NMTIPOLOCALCLI AS NMTIPOLOCALCLIFM
        FROM FCT_PARAMETROGERAL PARAM
        LEFT JOIN FCT_ORCAMENTOMODELO MODPRO ON PARAM.NRORCAMODELOCUST = MODPRO.NRORCAMENTOMODELO
        AND PARAM.NRORG = MODPRO.NRORG
        LEFT JOIN FCT_PRECBASESERV PRECO ON PARAM.CDPRECBASESERVCUST = PRECO.CDPRECBASESERV
        AND PARAM.NRORG = PRECO.NRORG
        LEFT JOIN FCT_TIPODOCCERTSIGN TIPODOC ON PARAM.NRTIPODOCCERTSIGN = TIPODOC.NRTIPODOCCERTSIGN
        AND PARAM.NRORG = TIPODOC.NRORG
        LEFT JOIN FCM_TIPOLOCALCLI ON FCM_TIPOLOCALCLI.NRTIPOLOCALCLI = PARAM.NRTIPOLOCALCLIFM
        GROUP BY PARAM.NRPARAMETROGERAL,
                PARAM.CDGRUPPRODORCA,
                PARAM.NRORG,
                PARAM.IDATIVO,
                PARAM.DTINCLUSAO,
                PARAM.DTULTATU,
                PARAM.NRORGINCLUSAO,
                PARAM.CDOPERINCLUSAO,
                PARAM.NRORGULTATU,
                PARAM.CDOPERULTATU,
                PARAM.IDGERARECURSO,
                PARAM.IDINICFATURA,
                PARAM.QTDIASDESALOCREC,
                PARAM.DSEMAILSDESALCREC,
                PARAM.IDALTERAMODCON,
                PARAM.IDALTERATABPREC,
                PARAM.CDMOTIVOACEITE,
                PARAM.CDMOTIVOENVIO,
                PARAM.CDINDFINCONT,
                PARAM.CDTPINDFINCON,
                PARAM.IDPERVALFINCON,
                PARAM.NRSEQMODCONTRATO,
                PARAM.CDMODCONTRATO,
                PARAM.IDOBRIGMODORC,
                PARAM.NRINISEQCODORCA,
                PARAM.NRINISEQCODCONT,
                PARAM.QTDIASALERTACONTRATO,
                PARAM.IDUTILIZAHIEROPER,
                PARAM.IDINTEGRACAOOM,
                PARAM.URLINTEGRACAOOM,
                PARAM.IDCONVERSAOPROSPECT,
                PARAM.IDCONVCLIENTE,
                PARAM.IDINTEGRACAOCRM,
                PARAM.URLINTEGRACAOCRM,
                PARAM.IDALTERAPROPCONC,
                PARAM.IDALTERACONTAPROV,
                PARAM.NRORCAMODELOCUST,
                MODPRO.NMORCAMENTOMODELO,
                PARAM.CDPRECBASESERVCUST,
                PRECO.DSPRECBASESERV,
                PARAM.DSHOSTEMAIL,
                PARAM.DSPORTAEMAIL,
                PARAM.DSUSUARIOEMAIL,
                PARAM.DSSENHAEMAIL,
                PARAM.IDBLOQREAJSEMALIQ,
                PARAM.IDBLOQAPURFATSEMREAJ,
                PARAM.DSEMAILALERTRENOVCONT,
                PARAM.IDPERIODALERTRENOVCONT,
                PARAM.DSTOKENCERTSIGN,
                PARAM.NMSENDERCERTSIGN,
                PARAM.DSEMAILSENDERCERTSIGN,
                PARAM.NRCPFSENDERCERTSIGN,
                PARAM.IDSMTPSECURE,
                PARAM.IDBUSCADTVENCNF,
                PARAM.NRTIPODOCCERTSIGN,
                TIPODOC.NMTIPODOCCERTSIGN,
                PARAM.IDPADRAOASSINACERTSIGN,
                PARAM.IDBLOQCARENCMAXI,
                PARAM.IDVALIDACPFRF,
                PARAM.URLINTEGRACAOERPFILIAL,
                PARAM.DSURLINTEGRACAOFM,
                PARAM.NRTIPOLOCALCLIFM,
                PARAM.URLINTEGRACAOTECFOOD,
                FCM_TIPOLOCALCLI.NMTIPOLOCALCLI";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, [], [], null, null, null, array('FCT_ALTPROPCONCPERF', 'FCT_ALTCONTRAPROVPERF'));
    }

    public function getNomePerfAcess()
    {
        $sql = "SELECT DISTINCT PERF.NMPERFILACESSO, PERF.NRPERFILACESSO AS NRPERFILACESSO
                FROM PERFILACESSO PERF 
                LEFT JOIN PERFACESSPARC PER ON PER.NRPERFILACESSO = PERF.NRPERFILACESSO";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function buscaNovoCodigo($params)
    {
        $sql = "SELECT NRSEQUENCIAL 
                  FROM NOVOCODIGO 
                 WHERE CDCONTADOR = :CDCONTADOR 
                   AND NRORG = :NRORG";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);
    }

    public function atualizaNovoCodigo($params)
    {
        $sql = "UPDATE NOVOCODIGO
                   SET NRSEQUENCIAL = :NRSEQUENCIAL,
                       NRORGULTATU  = :NRORG,
                       CDOPERULTATU = :OPERADOR,
                       DTULTATU = SYSDATE
                 WHERE CDCONTADOR = :CDCONTADOR
                   AND NRORG = :NRORG";

        $this->connection->executeStatement($sql, $params);
    }

    public function insereNovoCodigo($params)
    {
        $sql = "INSERT INTO NOVOCODIGO(
                    CDCONTADOR, NRSEQUENCIAL, NRORG, DTINCLUSAO, NRORGINCLUSAO,
                    CDOPERINCLUSAO, IDATIVO)
                VALUES(
                    :CDCONTADOR, :NRSEQUENCIAL, :NRORG, SYSDATE, :NRORG,
                    :OPERADOR, 'S')";

        $this->connection->executeStatement($sql, $params);
    }

    public function buscarperfilacessoContrato($params)
    {
        $sql = "SELECT NRPERFILACESSO FROM FCT_ALTCONTRAPROVPERF WHERE NRORG = :NRORG";
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);
    }

    public function buscarperfilacessoProposta($params)
    {
        $sql = "SELECT NRPERFILACESSO FROM FCT_ALTPROPCONCPERF WHERE NRORG = :NRORG";
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);
    }

    public function saveperfilacessoProposta($params)
    {
        $sql = "INSERT INTO FCT_ALTPROPCONCPERF(NRALTPROPCONCPERF, NRPERFILACESSO,NRORG, NRORGINCLUSAO,
                    CDOPERINCLUSAO, CDOPERULTATU, NRORGULTATU, DTINCLUSAO, DTULTATU, IDATIVO)
                VALUES (
                    :NRALTCONTRAPROVPERF, :NRPERFILACESSO, :NRORG, :NRORGINCLUSAO,
                    :CDOPERINCLUSAO, :CDOPERULTATU, :NRORGULTATU, :DTINCLUSAO, :DTULTATU, :IDATIVO)";
        $this->connection->executeStatement($sql, $params);
    }

    public function saveperfilacessoContrato($params)
    {
        $sql = "INSERT INTO FCT_ALTCONTRAPROVPERF(NRALTCONTRAPROVPERF, NRPERFILACESSO,NRORG, NRORGINCLUSAO,
                    CDOPERINCLUSAO, CDOPERULTATU, NRORGULTATU, DTINCLUSAO, DTULTATU, IDATIVO)
                VALUES (
                    :NRALTCONTRAPROVPERF, :NRPERFILACESSO, :NRORG, :NRORGINCLUSAO,
                    :CDOPERINCLUSAO, :CDOPERULTATU, :NRORGULTATU, :DTINCLUSAO, :DTULTATU, :IDATIVO)";
        $this->connection->executeStatement($sql, $params);
    }

    public function deleteperfilacessoContrato($params)
    {
        $sql = "DELETE FROM FCT_ALTCONTRAPROVPERF WHERE NRPERFILACESSO = :NRPERFILACESSO";
        $this->connection->executeStatement($sql, $params);
    }

    public function deleteperfilacessoProposta($params)
    {
        $sql = "DELETE FROM FCT_ALTPROPCONCPERF WHERE NRPERFILACESSO = :NRPERFILACESSO";
        $this->connection->executeStatement($sql, $params);
    }

    public function saveDadosParametrosService($params)
    {
        $sql = "UPDATE FCT_PARAMETROGERAL
                   SET  IDUTILIZAHIEROPER      = :IDUTILIZAHIEROPER,
                        IDVALIDACPFRF          = :IDVALIDACPFRF,
                        IDOBRIGMODORC          = :IDOBRIGMODORC,         
                        IDCONVCLIENTE          = :IDCONVCLIENTE,    
                        NRINISEQCODORCA        = :NRINISEQCODORCA,    
                        IDALTERAPROPCONC       = :IDALTERAPROPCONC,    
                        NRINISEQCODCONT        = :NRINISEQCODCONT,    
                        IDALTERACONTAPROV      = :IDALTERACONTAPROV,    
                        IDBUSCADTVENCNF        = :IDBUSCADTVENCNF,    
                        DSEMAILALERTRENOVCONT  = :DSEMAILALERTRENOVCONT,    
                        IDPERIODALERTRENOVCONT = :IDPERIODALERTRENOVCONT,    
                        IDBLOQREAJSEMALIQ      = :IDBLOQREAJSEMALIQ,    
                        IDBLOQAPURFATSEMREAJ   = :IDBLOQAPURFATSEMREAJ,    
                        DSHOSTEMAIL            = :DSHOSTEMAIL,    
                        DSPORTAEMAIL           = :DSPORTAEMAIL,    
                        DSUSUARIOEMAIL         = :DSUSUARIOEMAIL,    
                        DSSENHAEMAIL           = :DSSENHAEMAIL,    
                        IDSMTPSECURE           = :IDSMTPSECURE,    
                        DSURLINTEGRACAOFM      = :DSURLINTEGRACAOFM,    
                        DSTOKENCERTSIGN        = :DSTOKENCERTSIGN,    
                        NMSENDERCERTSIGN       = :NMSENDERCERTSIGN,    
                        DSEMAILSENDERCERTSIGN  = :DSEMAILSENDERCERTSIGN,    
                        NRCPFSENDERCERTSIGN    = :NRCPFSENDERCERTSIGN,    
                        IDPADRAOASSINACERTSIGN = :IDPADRAOASSINACERTSIGN,    
                        URLINTEGRACAOERPFILIAL = :URLINTEGRACAOERPFILIAL,
                        NRTIPOLOCALCLIFM       = :NRTIPOLOCALCLIFM,
                        NRTIPODOCCERTSIGN      = :NRTIPODOCCERTSIGN,
                        URLINTEGRACAOTECFOOD   = :URLINTEGRACAOTECFOOD
                 WHERE NRPARAMETROGERAL = 1";

        $this->connection->executeStatement($sql, $params);
    }
}
