<?php
namespace SM\Service;

use DateTime;
use SM\Factory\CentroCustoRelatorioFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Zeedhi\Framework\DataSource\DataSet;

class CentroCustoRelatorioService
{

    protected $centroCustoRelatorioFactory;
    protected $Environment;
    protected $newCode;

    public function __construct(CentroCustoRelatorioFactory $centroCustoRelatorioFactory, Environment $Environment, NewCode $newCode)
    {
        $this->centroCustoRelatorioFactory  = $centroCustoRelatorioFactory;
        $this->Environment               = $Environment;
        $this->newCode                   = $newCode;
    }

    public function getCentroCustoRelatorio()
    {
        return $this->centroCustoRelatorioFactory->getCentroCustoRelatorio();
    }

    public function getDataUltimaAtualizacaoRelatorioCentroCusto()
    {
        $dados = $this->centroCustoRelatorioFactory->getDataUltimaAtualizacaoRelatorioCentroCusto();
        return $dados[0]["DTULTATUMVCCUSTOCONT"];
    }

    public function atualizarView()
    {
        return $this->centroCustoRelatorioFactory->atualizarView();
    }
}
